Index: xalloc/Makefile.am
===================================================================
--- xalloc/Makefile.am	(revision 0816f71425281ce41a6a64263309ea59a13ade6e)
+++ xalloc/Makefile.am	(revision 58543e3f682941d3b62b869286d766749a9a385b)
@@ -21,2 +21,20 @@
 CLEANFILES = $(BUILT_SOURCES)
 
+prefix=@prefix@
+exec_prefix=@exec_prefix@
+libdir=@libdir@
+includedir=@includedir@
+
+Name: omalloc
+Description: The Singular memory manager
+Version: @PACKAGE_VERSION@
+URL: https://github.com/Singular/Sources/tree/spielwiese/@PACKAGE@
+
+# Requires:
+# Conflicts:
+
+Cflags: -I${includedir}
+Libs: -L${libdir} -lomalloc
+# Libs.private:
+
+
Index: xalloc/configure.ac
===================================================================
--- xalloc/configure.ac	(revision 0816f71425281ce41a6a64263309ea59a13ade6e)
+++ xalloc/configure.ac	(revision 58543e3f682941d3b62b869286d766749a9a385b)
@@ -1,104 +1,40 @@
-dnl lllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllll
-dnl File: configure.ac
-dnl Purpose: Process this file with autoconf to produce configure
-dnl Author:  obachman@mathematik.uni-kl.de (Olaf Bachmann)
-dnl Created: 11/99
-dnl lllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllll
+ACLOCAL_AMFLAGS = -I ../m4
 
-AC_INIT([xmalloc],[4.0])
+lib_LTLIBRARIES=libomalloc.la
 
-AC_CONFIG_MACRO_DIR([../m4])
-AC_CONFIG_AUX_DIR([../build-aux])
-AC_CONFIG_SRCDIR(dummy.c)
-#AC_CONFIG_HEADER([_config.h])
+libomalloc_includedir=$(includedir)/omalloc
 
-AC_PROG_CC
-AC_PROG_CXX
+libomalloc_include_HEADERS = omalloc.h omallocClass.h
 
-SING_RESET_FLAGS()
+SOURCES=dummy.c omallocClass.cc
 
-AM_MAINTAINER_MODE([enable])
-AM_INIT_AUTOMAKE([-Wall foreign subdir-objects]) # -Wno-extra-portability -Werror silent-rules
-m4_ifdef([AM_SILENT_RULES], [AM_SILENT_RULES([yes])])
-m4_ifdef([AM_PROG_AR], [AM_PROG_AR])
+AM_CPPFLAGS =-I${top_srcdir}/.. -I${top_builddir}/..
 
-AM_SANITY_CHECK
+libomalloc_la_SOURCES=$(SOURCES) $(noinst_HEADERS)
 
-# Add pre'prefixed config
-#AX_PREFIX_CONFIG_H([omConfig.h],[],[_config.h])
+libomalloc_la_LDFLAGS    = -release ${PACKAGE_VERSION}
 
-# SING_CHECK_SET_ARGS()
+libomalloc_la_CPPFLAGS  = ${AM_CPPFLAGS}
 
-#AC_SUBST(VERSION)
+omTables_CPPFLAGS = ${AM_CPPFLAGS}
 
-CPPFLAGS="-I.. -I. $CPPFLAGS"
-AC_PROG_MAKE_SET
-AC_PROG_CC
-AC_PROG_CPP
+CLEANFILES = $(BUILT_SOURCES)
 
-AC_PROG_LN_S
-AC_PROG_INSTALL
-AM_PROG_CC_C_O
-# AM_PROG_AR
-AC_C_CONST
-AC_C_INLINE
+prefix=@prefix@
+exec_prefix=@exec_prefix@
+libdir=@libdir@
+includedir=@includedir@
 
-LT_INIT
+Name: omalloc
+Description: The Singular memory manager
+Version: @PACKAGE_VERSION@
+URL: https://github.com/Singular/Sources/tree/spielwiese/@PACKAGE@
+
+# Requires:
+# Conflicts:
+
+Cflags: -I${includedir}
+Libs: -L${libdir} -lomalloc
+# Libs.private:
 
 
-dnl lllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllll
-dnl check for programs
-dnl
-AC_CHECK_PROG(AR, ar, ar, :)
-if test "$ac_cv_prog_AR" = no; then
-  AC_MSG_ERROR(*** ar program not found)
-fi
-
-dnl lllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllll
-dnl header file checks
-dnl
-AC_HEADER_STDC
-AC_CHECK_HEADERS(limits.h,,
-  AC_MSG_ERROR(Can not compile without limits.h))
-
-AC_CHECK_HEADERS(unistd.h sys/mman.h fcntl.h /usr/include/malloc.h)
-
-AC_CHECK_FUNCS(popen mmap sbrk random)
-
-dnl llllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllll
-dnl Find out more about particularity of the system
-dnl
-
-# sizes
-AC_CHECK_SIZEOF(long,4)
-AC_CHECK_SIZEOF(void*,4)
-AC_CHECK_SIZEOF(double, 8)
-AC_CHECK_SIZEOF(size_t, 4)
-
-if test "$ac_cv_sizeof_long" != "$ac_cv_sizeof_voidp"; then
-  AC_MSG_ERROR(need equal sizes for long and void*)
-fi
-if test "$ac_cv_sizeof_voidp" != 4 && test "$ac_cv_sizeof_voidp" != 8; then
-  AC_MSG_ERROR(need void* to be 4 or 8 bytes long)
-fi
-if test "$ac_cv_sizeof_double" != 4 && test "$ac_cv_sizeof_double" != 8; then
-  AC_MSG_ERROR(need double to be 4 or 8 bytes long)
-fi
-
-dnl Set compiler, linker flags so that we can work with omalloc
-BACKUP_CFLAGS=$CFLAGS
-BACKUP_CXXFLAGS=$CXXFLAGS
-BACKUP_LDFLAGS=$LDFLAGS
-
-CFLAGS="$CFLAGS -I$srcdir"
-CXXFLAGS="$CXXFLAGS -I$srcdir"
-
-AC_SUBST(OM_MALLOC_HEADER)
-AC_SUBST(OM_MALLOC_SOURCE)
-
-dnl lllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllll
-dnl wrap it up
-dnl
-AC_CONFIG_FILES([Makefile])
-AC_OUTPUT
-