Index: Singular/Makefile.am
===================================================================
--- Singular/Makefile.am	(revision 63264112a72e246bbbe0ced36fa4fb72f5872c22)
+++ Singular/Makefile.am	(revision 244674a449d5bc275027b89dc6f0447358e8b8c9)
@@ -1,5 +1,5 @@
 ACLOCAL_AMFLAGS = -I../m4
 
-AM_CPPFLAGS = -I${top_srcdir} -I${top_builddir} -I${top_srcdir}/kernel -I${top_builddir}/kernel -I${top_srcdir}/libpolys -I${top_builddir}/libpolys $(FACTORY_INCLUDES) $(CCLUSTER_CPPFLAGS)  $(GMP_CPPFLAGS) $(FLINT_CFLAGS)
+AM_CPPFLAGS = -I${top_srcdir} -I${top_builddir} -I${top_srcdir}/kernel -I${top_builddir}/kernel -I${top_srcdir}/libpolys -I${top_builddir}/libpolys $(FACTORY_INCLUDES) $(CCLUSTER_CPPFLAGS)  $(GMP_CPPFLAGS) $(FLINT_CFLAGS) ${NTL_CPPFLAGS}
 
 AM_CXXFLAGS=$(NTL_CPPFLAGS) -fno-delete-null-pointer-checks
Index: kernel/GBEngine/Makefile.am
===================================================================
--- kernel/GBEngine/Makefile.am	(revision 63264112a72e246bbbe0ced36fa4fb72f5872c22)
+++ kernel/GBEngine/Makefile.am	(revision 244674a449d5bc275027b89dc6f0447358e8b8c9)
@@ -2,5 +2,5 @@
 AM_CPPFLAGS=-I${top_srcdir} -I${top_builddir} -I${top_srcdir}/libpolys -I${top_builddir}/libpolys \
 ${FACTORY_INCLUDES} $(OMALLOC_INCLUDES) $(RESOURCES_INCLUDES) \
-${GMP_CPPFLAGS}
+${FLINT_CFLAGS} ${NTL_CPPFLAGS} ${GMP_CPPFLAGS}
 
 noinst_LTLIBRARIES=libGBEngine.la
Index: kernel/Makefile.am
===================================================================
--- kernel/Makefile.am	(revision 63264112a72e246bbbe0ced36fa4fb72f5872c22)
+++ kernel/Makefile.am	(revision 244674a449d5bc275027b89dc6f0447358e8b8c9)
@@ -5,5 +5,5 @@
 AM_CPPFLAGS = \
 -I${top_srcdir} -I${top_builddir} -I${top_srcdir}/libpolys -I${top_builddir}/libpolys \
-$(FACTORY_INCLUDES) $(GMP_CPPFLAGS)
+$(FACTORY_INCLUDES) ${NTL_CPPFLAGS} ${FLINT_CFLAGS} $(GMP_CPPFLAGS)
 
 SOURCES = polys.cc \
Index: kernel/combinatorics/Makefile.am
===================================================================
--- kernel/combinatorics/Makefile.am	(revision 63264112a72e246bbbe0ced36fa4fb72f5872c22)
+++ kernel/combinatorics/Makefile.am	(revision 244674a449d5bc275027b89dc6f0447358e8b8c9)
@@ -2,5 +2,5 @@
 AM_CPPFLAGS=-I${top_srcdir} -I${top_builddir} -I${top_srcdir}/libpolys -I${top_builddir}/libpolys \
 ${FACTORY_INCLUDES} $(OMALLOC_INCLUDES) $(RESOURCES_INCLUDES) \
-${GMP_CPPFLAGS}
+${NTL_CPPFLAGS} $(FLINT_CFLAGS) ${GMP_CPPFLAGS}
 
 noinst_LTLIBRARIES=libcombinatorics.la
Index: kernel/fglm/Makefile.am
===================================================================
--- kernel/fglm/Makefile.am	(revision 63264112a72e246bbbe0ced36fa4fb72f5872c22)
+++ kernel/fglm/Makefile.am	(revision 244674a449d5bc275027b89dc6f0447358e8b8c9)
@@ -2,5 +2,5 @@
 AM_CPPFLAGS=-I${top_srcdir} -I${top_builddir} -I${top_srcdir}/libpolys -I${top_builddir}/libpolys \
 ${FACTORY_INCLUDES} $(OMALLOC_INCLUDES) $(RESOURCES_INCLUDES) \
-${GMP_CPPFLAGS}
+${NTL_CPPFLAGS} $(FLINT_CFLAGS) ${GMP_CPPFLAGS}
 
 noinst_LTLIBRARIES=libfglm.la
Index: kernel/groebner_walk/Makefile.am
===================================================================
--- kernel/groebner_walk/Makefile.am	(revision 63264112a72e246bbbe0ced36fa4fb72f5872c22)
+++ kernel/groebner_walk/Makefile.am	(revision 244674a449d5bc275027b89dc6f0447358e8b8c9)
@@ -2,5 +2,5 @@
 AM_CPPFLAGS=-I${top_srcdir} -I${top_builddir} -I${top_srcdir}/libpolys -I${top_builddir}/libpolys \
 ${FACTORY_INCLUDES} $(OMALLOC_INCLUDES) $(RESOURCES_INCLUDES) \
-${GMP_CPPFLAGS}
+${NTL_CPPFLAGS} $(FLINT_CFLAGS) ${GMP_CPPFLAGS}
 
 noinst_LTLIBRARIES=libgroebner_walk.la
Index: kernel/linear_algebra/Makefile.am
===================================================================
--- kernel/linear_algebra/Makefile.am	(revision 63264112a72e246bbbe0ced36fa4fb72f5872c22)
+++ kernel/linear_algebra/Makefile.am	(revision 244674a449d5bc275027b89dc6f0447358e8b8c9)
@@ -2,5 +2,5 @@
 AM_CPPFLAGS=-I${top_srcdir} -I${top_builddir} -I${top_srcdir}/libpolys -I${top_builddir}/libpolys \
 ${FACTORY_INCLUDES} $(OMALLOC_INCLUDES) $(RESOURCES_INCLUDES) \
-${GMP_CPPFLAGS}
+${FLINT_CFLAGS} ${NTL_CPPFLAGS} ${GMP_CPPFLAGS}
 
 noinst_LTLIBRARIES=liblinear_algebra.la
Index: kernel/maps/Makefile.am
===================================================================
--- kernel/maps/Makefile.am	(revision 63264112a72e246bbbe0ced36fa4fb72f5872c22)
+++ kernel/maps/Makefile.am	(revision 244674a449d5bc275027b89dc6f0447358e8b8c9)
@@ -2,5 +2,5 @@
 AM_CPPFLAGS=-I${top_srcdir} -I${top_builddir} -I${top_srcdir}/libpolys -I${top_builddir}/libpolys \
 ${FACTORY_INCLUDES} $(OMALLOC_INCLUDES) $(RESOURCES_INCLUDES) \
-${GMP_CPPFLAGS}
+${NTL_CPPFLAGS} $(FLINT_CFLAGS) ${GMP_CPPFLAGS}
 
 noinst_LTLIBRARIES=libmaps.la
Index: kernel/numeric/Makefile.am
===================================================================
--- kernel/numeric/Makefile.am	(revision 63264112a72e246bbbe0ced36fa4fb72f5872c22)
+++ kernel/numeric/Makefile.am	(revision 244674a449d5bc275027b89dc6f0447358e8b8c9)
@@ -3,5 +3,5 @@
 -I${top_srcdir}/libpolys -I${top_builddir}/libpolys \
 ${FACTORY_INCLUDES} ${RESOURCES_INCLUDES} ${OMALLOC_INCLUDES} \
-${GMP_CPPFLAGS}
+${NTL_CPPFLAGS} $(FLINT_CFLAGS) ${GMP_CPPFLAGS}
 
 noinst_LTLIBRARIES=libnumeric.la
Index: kernel/oswrapper/Makefile.am
===================================================================
--- kernel/oswrapper/Makefile.am	(revision 63264112a72e246bbbe0ced36fa4fb72f5872c22)
+++ kernel/oswrapper/Makefile.am	(revision 244674a449d5bc275027b89dc6f0447358e8b8c9)
@@ -2,5 +2,5 @@
 AM_CPPFLAGS=-I${top_srcdir} -I${top_builddir} -I${top_srcdir}/libpolys -I${top_builddir}/libpolys \
 ${FACTORY_INCLUDES} $(OMALLOC_INCLUDES) $(RESOURCES_INCLUDES) \
-${GMP_CPPFLAGS}
+${NTL_CPPFLAGS} $(FLINT_CFLAGS) ${GMP_CPPFLAGS}
 
 AM_CXXFLAGS=
Index: kernel/sample/Makefile.am
===================================================================
--- kernel/sample/Makefile.am	(revision 63264112a72e246bbbe0ced36fa4fb72f5872c22)
+++ kernel/sample/Makefile.am	(revision 244674a449d5bc275027b89dc6f0447358e8b8c9)
@@ -2,5 +2,5 @@
 AM_CPPFLAGS=-I${top_srcdir} -I${top_builddir} -I${top_srcdir}/libpolys -I${top_builddir}/libpolys \
 ${FACTORY_INCLUDES} $(OMALLOC_INCLUDES) $(RESOURCES_INCLUDES) \
-${GMP_CPPFLAGS}
+${NTL_CPPFLAGS} $(FLINT_CFLAGS) ${GMP_CPPFLAGS}
 
 noinst_LTLIBRARIES=libsample.la
Index: kernel/spectrum/Makefile.am
===================================================================
--- kernel/spectrum/Makefile.am	(revision 63264112a72e246bbbe0ced36fa4fb72f5872c22)
+++ kernel/spectrum/Makefile.am	(revision 244674a449d5bc275027b89dc6f0447358e8b8c9)
@@ -2,5 +2,5 @@
 AM_CPPFLAGS=-I${top_srcdir} -I${top_builddir} -I${top_srcdir}/libpolys -I${top_builddir}/libpolys \
 ${FACTORY_INCLUDES} $(OMALLOC_INCLUDES) $(RESOURCES_INCLUDES) \
-${GMP_CPPFLAGS}
+${NTL_CPPFLAGS} $(FLINT_CFLAGS) ${GMP_CPPFLAGS}
 
 noinst_LTLIBRARIES=libspectrum.la
Index: libpolys/libpolys-config.in
===================================================================
--- libpolys/libpolys-config.in	(revision 63264112a72e246bbbe0ced36fa4fb72f5872c22)
+++ libpolys/libpolys-config.in	(revision 244674a449d5bc275027b89dc6f0447358e8b8c9)
@@ -90,5 +90,5 @@
     --cflags)
     #### @FACTORY_INCLUDES@
-	${ECHOn} " -I${includedir} -I${includedir}/singular @SINGULAR_CFLAGS@ @GMP_CPPFLAGS@ "
+	${ECHOn} " -I${includedir} -I${includedir}/singular @SINGULAR_CFLAGS@ @FLINT_CFLAGS@ @NTL_CPPFLAGS@ @GMP_CPPFLAGS@ "
 	;;
 
Index: libpolys/libpolys.pc.in
===================================================================
--- libpolys/libpolys.pc.in	(revision 63264112a72e246bbbe0ced36fa4fb72f5872c22)
+++ libpolys/libpolys.pc.in	(revision 244674a449d5bc275027b89dc6f0447358e8b8c9)
@@ -12,5 +12,5 @@
 Conflicts:
 
-Cflags: -I${includedir} -I${includedir}/singular @SINGULAR_CFLAGS@ @FLINT_CFLAGS@ @GMP_CPPFLAGS@
+Cflags: -I${includedir} -I${includedir}/singular @SINGULAR_CFLAGS@ @FLINT_CFLAGS@ @NTL_CPPFLAGS@ @GMP_CPPFLAGS@
 Libs: -L${libdir} -lpolys @FLINT_LIBS@ @GMP_LIBS@ @USEPPROCSDYNAMICLD@
 Libs.private:
Index: libpolys/polys/Makefile.am
===================================================================
--- libpolys/polys/Makefile.am	(revision 63264112a72e246bbbe0ced36fa4fb72f5872c22)
+++ libpolys/polys/Makefile.am	(revision 244674a449d5bc275027b89dc6f0447358e8b8c9)
@@ -3,5 +3,5 @@
 AM_CPPFLAGS	= -I${top_srcdir} -I${top_builddir} \
 ${FACTORY_INCLUDES} ${RESOURCES_INCLUDES} ${OMALLOC_INCLUDES} \
-${FLINT_CFLAGS} ${GMP_CPPFLAGS}
+${FLINT_CFLAGS} ${NTL_CPPFLAGS} ${GMP_CPPFLAGS}
 
 AM_CXXFLAGS =
Index: libpolys/reporter/Makefile.am
===================================================================
--- libpolys/reporter/Makefile.am	(revision 63264112a72e246bbbe0ced36fa4fb72f5872c22)
+++ libpolys/reporter/Makefile.am	(revision 244674a449d5bc275027b89dc6f0447358e8b8c9)
@@ -1,5 +1,5 @@
 ACLOCAL_AMFLAGS = -I ../../m4
 
-AM_CPPFLAGS = -I${top_srcdir} -I${top_srcdir}/.. -I${top_builddir} -I${top_builddir}/..  $(FACTORY_INCLUDES) ${GMP_CPPFLAGS}
+AM_CPPFLAGS = -I${top_srcdir} -I${top_srcdir}/.. -I${top_builddir} -I${top_builddir}/..  $(FACTORY_INCLUDES)  ${FLINT_CFLAGS}  ${NTL_CPPFLAGS} ${GMP_CPPFLAGS}
 
 noinst_LTLIBRARIES = libreporter.la
Index: libpolys/tests/Makefile.am
===================================================================
--- libpolys/tests/Makefile.am	(revision 63264112a72e246bbbe0ced36fa4fb72f5872c22)
+++ libpolys/tests/Makefile.am	(revision 244674a449d5bc275027b89dc6f0447358e8b8c9)
@@ -3,5 +3,5 @@
 AM_CPPFLAGS = -I${top_srcdir} -I${top_builddir} \
 ${FACTORY_INCLUDES} ${RESOURCES_INCLUDES} ${OMALLOC_INCLUDES} \
-${FLINT_CFLAGS} ${GMP_CPPFLAGS}
+${FLINT_CFLAGS}  ${NTL_CPPFLAGS} ${GMP_CPPFLAGS}
 
 TESTS = simple_test \
Index: libsingular-config.in
===================================================================
--- libsingular-config.in	(revision 63264112a72e246bbbe0ced36fa4fb72f5872c22)
+++ libsingular-config.in	(revision 244674a449d5bc275027b89dc6f0447358e8b8c9)
@@ -90,5 +90,5 @@
     --cflags)
     #### @FACTORY_INCLUDES@
-	${ECHOn} " -I${includedir} -I${includedir}/singular @SINGULAR_CFLAGS@  @GMP_CPPFLAGS@ "
+	${ECHOn} " -I${includedir} -I${includedir}/singular @SINGULAR_CFLAGS@  @FLINT_CFLAGS@ @NTL_CPPFLAGS@ @GMP_CPPFLAGS@ "
 	;;
 