Index: doc/images/bg.jpg.uu
===================================================================
--- doc/images/bg.jpg.uu	(revision 877605d1338b4f0ed83344657f95df0a346fca17)
+++ doc/images/bg.jpg.uu	(revision 877605d1338b4f0ed83344657f95df0a346fca17)
@@ -0,0 +1,61 @@
+begin 644 bg.jpg
+M_]C_X``02D9)1@`!`@$`2`!(``#_[02Z4&AO=&]S:&]P(#,N,``X0DE-`^D`
+M`````'@``P```$@`2``````"V@(H_^'_X@+Y`D8#1P4H`_P``@```$@`2```
+M```"V`(H``$```!D`````0`#`P,````!)P\``0`!````````````````8`@`
+M&0&0```````````````````````````````````````````X0DE-`^T`````
+M`!``2`````$``0!(`````0`!.$))30/S```````(```````````X0DE-!`H`
+M``````$``#A"24TG$```````"@`!``````````(X0DE-`_4``````$@`+V9F
+M``$`;&9F``8```````$`+V9F``$`H9F:``8```````$`,@````$`6@````8`
+M``````$`-0````$`+0````8```````$X0DE-`_@``````'```/__________
+M__________________\#Z`````#_____________________________`^@`
+M````_____________________________P/H`````/__________________
+M__________\#Z```.$))300````````"``(X0DE-!`(```````8````````X
+M0DE-!`@``````!`````!```"0````D``````.$))300)``````*F`````0``
+M`(`````!```!@````8````**`!@``?_8_^``$$I&248``0(!`$@`2```__X`
+M)T9I;&4@=W)I='1E;B!B>2!!9&]B92!0:&]T;W-H;W"H(#0N,`#_[@`.061O
+M8F4`9(`````!_]L`A``,"`@("0@,"0D,$0L*"Q$5#PP,#Q48$Q,5$Q,8$0P,
+M#`P,#!$,#`P,#`P,#`P,#`P,#`P,#`P,#`P,#`P,#`P,`0T+"PT.#1`.#A`4
+M#@X.%!0.#@X.%!$,#`P,#!$1#`P,#`P,$0P,#`P,#`P,#`P,#`P,#`P,#`P,
+M#`P,#`P,#`S_P``1"``!`(`#`2(``A$!`Q$!_]T`!``(_\0!/P```04!`0$!
+M`0$``````````P`!`@0%!@<("0H+`0`!!0$!`0$!`0`````````!``(#!`4&
+M!P@)"@L0``$$`0,"!`(%!P8(!0,,,P$``A$#!"$2,05!46$3(G&!,@84D:&Q
+M0B,D%5+!8C,T<H+10P<EDE/PX?%C<S46HK*#)D235&1%PJ-T-A?25>)E\K.$
+MP]-UX_-&)Y2DA;25Q-3D]*6UQ=7E]59F=H:6IK;&UN;V-T=79W>'EZ>WQ]?G
+M]Q$``@(!`@0$`P0%!@<'!@4U`0`"$0,A,1($05%A<2(3!3*!D12AL4(CP5+1
+M\#,D8N%R@I)#4Q5C<S3Q)086HK*#!R8UPM)$DU2C%V1%539T9>+RLX3#TW7C
+M\T:4I(6TE<34Y/2EM<75Y?569G:&EJ:VQM;F]B<W1U=G=X>7I[?'_]H`#`,!
+M``(1`Q$`/P#O_JQ_R4/^-M_\^/6LOE5)-A\D?[H_)=/YI>9?JI)?*J2<M?JI
+M)?*J22GZJ27RJDDI^JDE\JI)*?JI)?*J22GZJ27RJDDI^JDE\JI)*?_9.$))
+M300&```````'``0````!`0#__@`G1FEL92!W<FET=&5N(&)Y($%D;V)E(%!H
+M;W1O<VAO<*@@-"XP`/_N``Y!9&]B90!D``````'_VP"$``8$!`0%!`8%!08)
+M!@4&"0L(!@8("PP*"@L*"@P0#`P,#`P,$`P,#`P,#`P,#`P,#`P,#`P,#`P,
+M#`P,#`P,#`P!!P<'#0P-&!`0&!0.#@X4%`X.#@X4$0P,#`P,$1$,#`P,#`P1
+M#`P,#`P,#`P,#`P,#`P,#`P,#`P,#`P,#`P,#/_``!$(``H%``,!$0`"$0$#
+M$0'_W0`$`*#_Q`&B````!P$!`0$!```````````$!0,"!@$`!P@)"@L!``("
+M`P$!`0$!``````````$``@,$!08'"`D*"Q```@$#`P($`@8'`P0"!@)S`0(#
+M$00`!2$2,4%1!A-A(G&!%#*1H0<5L4(CP5+1X3,68O`D<H+Q)4,T4Y*BLF-S
+MPC5$)Y.CLS875&1TP]+B"":#"0H8&82414:DM%;352@:\N/SQ-3D]&5UA96E
+MM<75Y?5F=H:6IK;&UN;V-T=79W>'EZ>WQ]?G]SA(6&AXB)BHN,C8Z/@I.4E9
+M:7F)F:FYR=GI^2HZ2EIJ>HJ:JKK*VNKZ$0`"`@$"`P4%!`4&!`@#`VT!``(1
+M`P0A$C%!!5$382(&<8&1,J&Q\!3!T>$C0A528G+Q,R0T0X(6DE,EHF.RP@=S
+MTC7B1(,75),("0H8&28V11HG9'15-_*CL\,H*=/C\X24I+3$U.3T976%E:6U
+MQ=7E]4969G:&EJ:VQM;F]D=79W>'EZ>WQ]?G]SA(6&AXB)BHN,C8Z/@Y25EI
+M>8F9J;G)V>GY*CI*6FIZBIJJNLK:ZOK_V@`,`P$``A$#$0`_`#09T[S04;__
+M`'BN/^,3_P#$3E6?Z)?U2W8OKC_6#,OR`_X__P#C(/\`B(SG7?O:<5=BKL5=
+MBKL5=BKL5=BKL5=BKL5=BKL5=BKL5:P*V,0KL*NQ5V*NQ5V*NQ5V*NQ5V*NQ
+M5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ
+M5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ
+M5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ
+M5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ
+M5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ
+M5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5__T#09T[S04;__`'BN/^,3_P#$3E6?Z)?U
+M2W8OKC_6#,OR`_X__P#C(/\`B(SG7?O:<5=BKL5=BKL5=BKL5=BKL5=BKL5=
+MBKL5=BKL5:P*V,0KL*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ
+M5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ
+M5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ
+M5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ
+M5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ
+M5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ5V*NQ
+'5V*NQ5__V0``
+`
+end
Index: doc/images/bg_left.gif.uu
===================================================================
--- doc/images/bg_left.gif.uu	(revision 33471f8f9b05fd0fd0e9cbd9eb74b0c79fd75bae)
+++ doc/images/bg_left.gif.uu	(revision 877605d1338b4f0ed83344657f95df0a346fca17)
@@ -1,3 +1,3 @@
-begin 644 html/images/bg_left.gif
+begin 644 bg_left.gif
 M1TE&.#=A50!``/,``,#`P+:VMKN[N\O+R]#0T-75U?#P\/7U]?W]_?___P``
 M`````````````````````"P`````50!````$57#(2:N]..O-N_]@*(YD:9YH
Index: doc/images/bg_right.gif.uu
===================================================================
--- doc/images/bg_right.gif.uu	(revision 33471f8f9b05fd0fd0e9cbd9eb74b0c79fd75bae)
+++ doc/images/bg_right.gif.uu	(revision 877605d1338b4f0ed83344657f95df0a346fca17)
@@ -1,3 +1,3 @@
-begin 644 html/images/bg_right.gif
+begin 644 bg_right.gif
 M1TE&.#=AT@)"`/,``,#`P+:VMKN[N\O+R]#0T-75U?#P\/7U]?W]_?___P``
 M`````````````````````"P`````T@)"```$_A#)2:N]..O-N_]@*(YD:9YH
Index: doc/images/contents_motif.gif.uu
===================================================================
--- doc/images/contents_motif.gif.uu	(revision 33471f8f9b05fd0fd0e9cbd9eb74b0c79fd75bae)
+++ doc/images/contents_motif.gif.uu	(revision 877605d1338b4f0ed83344657f95df0a346fca17)
@@ -1,3 +1,3 @@
-begin 644 html/images/contents_motif.gif
+begin 644 contents_motif.gif
 M1TE&.#EA00`8`/$``+^_O^?GYV]O;UL``"'Y!`$`````+`````!!`!@```*R
 MC(^IR^T/HYQ-&("SWKS[#W*"%83FB8;CE;:NN9;O3&?Q-N1#S7]WE@/.=B^B
Index: doc/images/index_motif.gif.uu
===================================================================
--- doc/images/index_motif.gif.uu	(revision 33471f8f9b05fd0fd0e9cbd9eb74b0c79fd75bae)
+++ doc/images/index_motif.gif.uu	(revision 877605d1338b4f0ed83344657f95df0a346fca17)
@@ -1,3 +1,3 @@
-begin 644 html/images/index_motif.gif
+begin 644 index_motif.gif
 M1TE&.#EA*P`8`/$``+^_O^?GYV]O;UL``"'Y!`$`````+``````K`!@```*%
 MC(^IR^T/ES"@VHNSWE;,P(4BYU'C>98@RI+?-;!Q"ZBP3->O-9\]:^-58H,B
Index: doc/images/invisible.xbm.uu
===================================================================
--- doc/images/invisible.xbm.uu	(revision 33471f8f9b05fd0fd0e9cbd9eb74b0c79fd75bae)
+++ doc/images/invisible.xbm.uu	(revision 877605d1338b4f0ed83344657f95df0a346fca17)
@@ -1,3 +1,3 @@
-begin 644 html/images/invisible.xbm
+begin 644 invisible.xbm
 M(V1E9FEN92!D;W1?86YC:&]R7W=I9'1H(#$*(V1E9FEN92!D;W1?86YC:&]R
 M7VAE:6=H="`Q"G-T871I8R!C:&%R(&1O=%]A;F-H;W)?8FET<UM=(#T@>PH@
Index: doc/images/next_motif.gif.uu
===================================================================
--- doc/images/next_motif.gif.uu	(revision 33471f8f9b05fd0fd0e9cbd9eb74b0c79fd75bae)
+++ doc/images/next_motif.gif.uu	(revision 877605d1338b4f0ed83344657f95df0a346fca17)
@@ -1,3 +1,3 @@
-begin 644 html/images/next_motif.gif
+begin 644 next_motif.gif
 M1TE&.#EA)0`8`/$``+^_O^?GYV]O;UL``"'Y!`$`````+``````E`!@```)]
 MC(^IR^V_A`&TVHOS%3+H#V+<%);?Z)GJUE4#]JYB2PVQ*P,W@.+[;MKU:CK+
Index: doc/images/next_motif_gr.gif.uu
===================================================================
--- doc/images/next_motif_gr.gif.uu	(revision 33471f8f9b05fd0fd0e9cbd9eb74b0c79fd75bae)
+++ doc/images/next_motif_gr.gif.uu	(revision 877605d1338b4f0ed83344657f95df0a346fca17)
@@ -1,3 +1,3 @@
-begin 644 html/images/next_motif_gr.gif
+begin 644 next_motif_gr.gif
 M1TE&.#EA)0`8`/$``+^_O^?GYV]O;X*"@B'Y!`$`````+``````E`!@```)]
 MC(^IR^V_A`&TVHOS%3+H#V+<%);?Z)GJUE4#]JYB2PVQ*P,W@.+[;MKU:CK+
Index: doc/images/previous_motif.gif.uu
===================================================================
--- doc/images/previous_motif.gif.uu	(revision 33471f8f9b05fd0fd0e9cbd9eb74b0c79fd75bae)
+++ doc/images/previous_motif.gif.uu	(revision 877605d1338b4f0ed83344657f95df0a346fca17)
@@ -1,3 +1,3 @@
-begin 644 html/images/previous_motif.gif
+begin 644 previous_motif.gif
 M1TE&.#EA/P`8`/$``+^_O^?GYV]O;UL``"'Y!`$`````+``````_`!@```*M
 MC(^IR^T/HYQ)&("SWKS[#VJ"%83FB7[CE;8NN);O3`-Q-N1ZC0V\2,)I<K\B
Index: doc/images/previous_motif_gr.gif.uu
===================================================================
--- doc/images/previous_motif_gr.gif.uu	(revision 33471f8f9b05fd0fd0e9cbd9eb74b0c79fd75bae)
+++ doc/images/previous_motif_gr.gif.uu	(revision 877605d1338b4f0ed83344657f95df0a346fca17)
@@ -1,3 +1,3 @@
-begin 644 html/images/previous_motif_gr.gif
+begin 644 previous_motif_gr.gif
 M1TE&.#EA/P`8`/$``+^_O^?GYV]O;X*"@B'Y!`$`````+``````_`!@```*M
 MC(^IR^T/HYQ)&("SWKS[#VJ"%83FB7[CE;8NN);O3`-Q-N1ZC0V\2,)I<K\B
Index: doc/images/singular-1.jpg.uu
===================================================================
--- doc/images/singular-1.jpg.uu	(revision 33471f8f9b05fd0fd0e9cbd9eb74b0c79fd75bae)
+++ doc/images/singular-1.jpg.uu	(revision 877605d1338b4f0ed83344657f95df0a346fca17)
@@ -1,3 +1,3 @@
-begin 640 html/images/singular-1.jpg
+begin 640 singular-1.jpg
 M_]C_X``02D9)1@`!`0```0`!``#_VP!#``$!`0$!`0$!`0$!`0$!`0$!`0$!
 M`0$!`0$!`0$!`0$!`0$!`0$!`0$!`0$!`0$!`0$!`0$!`0$!`0$!`0$!`0'_
Index: doc/images/singular-2.jpg.uu
===================================================================
--- doc/images/singular-2.jpg.uu	(revision 33471f8f9b05fd0fd0e9cbd9eb74b0c79fd75bae)
+++ doc/images/singular-2.jpg.uu	(revision 877605d1338b4f0ed83344657f95df0a346fca17)
@@ -1,3 +1,3 @@
-begin 640 html/images/singular-2.jpg
+begin 640 singular-2.jpg
 M_]C_X``02D9)1@`!`0```0`!``#_VP!#``$!`0$!`0$!`0$!`0$!`0$!`0$!
 M`0$!`0$!`0$!`0$!`0$!`0$!`0$!`0$!`0$!`0$!`0$!`0$!`0$!`0$!`0'_
Index: doc/images/singular-3.jpg.uu
===================================================================
--- doc/images/singular-3.jpg.uu	(revision 33471f8f9b05fd0fd0e9cbd9eb74b0c79fd75bae)
+++ doc/images/singular-3.jpg.uu	(revision 877605d1338b4f0ed83344657f95df0a346fca17)
@@ -1,3 +1,3 @@
-begin 640 html/images/singular-3.jpg
+begin 640 singular-3.jpg
 M_]C_X``02D9)1@`!`0```0`!``#_VP!#``$!`0$!`0$!`0$!`0$!`0$!`0$!
 M`0$!`0$!`0$!`0$!`0$!`0$!`0$!`0$!`0$!`0$!`0$!`0$!`0$!`0$!`0'_
Index: doc/images/singular-small.jpg.uu
===================================================================
--- doc/images/singular-small.jpg.uu	(revision 33471f8f9b05fd0fd0e9cbd9eb74b0c79fd75bae)
+++ doc/images/singular-small.jpg.uu	(revision 877605d1338b4f0ed83344657f95df0a346fca17)
@@ -1,3 +1,3 @@
-begin 644 html/images/singular-small.jpg
+begin 644 singular-small.jpg
 M_]C_X``02D9)1@`!`0```0`!``#__@!'0U)%051/4CH@6%8@5F5R<VEO;B`S
 M+C`P("!2978Z(#,O,S`O.3,@(%%U86QI='D@/2`Q,#`L(%-M;V]T:&EN9R`]
Index: doc/images/singular.jpg.uu
===================================================================
--- doc/images/singular.jpg.uu	(revision 33471f8f9b05fd0fd0e9cbd9eb74b0c79fd75bae)
+++ doc/images/singular.jpg.uu	(revision 877605d1338b4f0ed83344657f95df0a346fca17)
@@ -1,3 +1,3 @@
-begin 644 html/images/singular.jpg
+begin 644 singular.jpg
 M_]C_X``02D9)1@`!`0```0`!``#_VP!#``H'!P@'!@H("`@+"@H+#A@0#@T-
 M#AT5%A$8(Q\E)"(?(B$F*S<O)BDT*2$B,$$Q-#D[/CX^)2Y$24,\2#<]/CO_
Index: doc/images/spacer3.gif.uu
===================================================================
--- doc/images/spacer3.gif.uu	(revision 877605d1338b4f0ed83344657f95df0a346fca17)
+++ doc/images/spacer3.gif.uu	(revision 877605d1338b4f0ed83344657f95df0a346fca17)
@@ -0,0 +1,4 @@
+begin 644 spacer3.gif
+M1TE&.#EA!0`%`(```/___P```"'Y!`$`````+``````%``4`0`($A(^I6``[
+`
+end